## Look at the input folder
## Look at the output folder
## Find the missing ones and generate
## - convert_custom
## - vbSPT command file
## - save in a .txt file that can be run in (GNU) parallel.

import os

in_folder = 'mat/'
out_folder = '.'
convert_folder = 'convert_files/'
command_folder = 'command_files/'
convert_template_path = 'templates/convert_template.m'
command_template_path = 'templates/command_template.m'
tp = "/absolute/path/to/the/folder/convert_files/"

with open(convert_template_path, 'r') as f:
    convert_template = f.read()
with open(command_template_path, 'r') as f:
    command_template = f.read()

out_list = os.listdir(out_folder)
for p in os.listdir(in_folder):
    if p not in out_list:
        dt = p.split("_dt")[1].split("s")[0]
        fn = "a_"+p[:-4].replace(".", "_")
        convert_tmp = convert_template
        command_tmp = command_template
        with open(os.path.join(convert_folder, fn+'.m'), 'w') as f:
            f.write(convert_tmp
                    .replace("{inputfile}", p)
                    .replace("{vbname}", fn)
                    .replace("{vbaddress}", os.path.join(command_folder, fn)))
        with open(os.path.join(command_folder, fn+'.m'), 'w') as f:
            f.write(command_tmp
                    .replace("{inputfile}", os.path.join(out_folder, "tmp/", p))
                    .replace("{outputfile}", os.path.join(out_folder, "results/", p))
                    .replace("{timestep}", dt))
        
        print """-nojvm -r "addpath('{}');{};exit" """.format(tp, fn)
