function [yes] = saveTrackedPar( csv_dir, file_name, out_dir  )
%SAVETRACKEDPAR 


matrix = csvread([csv_dir, file_name], 1);
xy = matrix(:,1:2);
Frames = matrix(:,5);
t = matrix(:,4);
traj = matrix(:,6);

%Now convert the data to a MATLAB convenient format: a structured array
trackedPar = struct;
iter = 1;
for i=1:size(xy,1)
    new = 0;
    %Determine whether the new trajectory is equal to the previous one
    NewTraj = traj(i); %Trajectory number
    if i == 1
        CurrTraj = NewTraj;
        new = 1;
    else
        if NewTraj ~= CurrTraj;
            CurrTraj = NewTraj;
            iter = iter + 1;
            new = 1;
        end
    end

    %Save the information
    if new == 1
        trackedPar(iter).xy = xy(i,:);
        trackedPar(iter).TimeStamp = t(i);
        trackedPar(iter).Frame = Frames(i)+1;
    else
        trackedPar(iter).xy = [trackedPar(iter).xy; xy(i,:)];
        trackedPar(iter).TimeStamp = [trackedPar(iter).TimeStamp; t(i)];
        trackedPar(iter).Frame = [trackedPar(iter).Frame; Frames(i)+1];
    end
end

% OK finished, now save the file
save_file_name = [file_name(1:end-4), '.mat'];
save([out_dir, save_file_name], 'trackedPar');

yes=1;
end

