%%%%%%%%%%%%%%%%%%%%%%%% These variables to adjust %%%%%%%%%%%%%%%%%%%%%%%%
% Define variables
path2 = '.';
currPath = 'mat/'
% Add paths that are needed to run the VB3 analysis 
dir0='./vbSPT1.1.4_20170411/';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

InputFile = '{inputfile}'; % automatically populated
MinTrajLength = 2;
%make directory
mkdir(path2);

addpath(genpath([dir0 filesep '.' filesep 'VB3']))
addpath(genpath([dir0 filesep '.' filesep 'HMMcore']))
addpath(genpath([dir0 filesep '.' filesep 'Tools']))
addpath(genpath([dir0 filesep '.' filesep 'external']))
addpath([dir0 filesep '.'])
disp('Added local vbSPT paths');
disp('---------------------');
clear dir0

 
AllData = [];
tic; disp('loading in the data...');
%Load data % REMOVE THIS BLOCK
% for n=1:length(input_struct)
%     currPath = input_struct(n).path;
%     currWorkspaces = input_struct(n).workspaces;
%     currInclude = input_struct(n).Include;
%     for i=1:length(currWorkspaces)
%         if currInclude(i) == 1
%             load([currPath, char(currWorkspaces(i))]);
%             AllData = [AllData trackedPar]; 
%         end
%     end
% end
load([currPath, InputFile])
AllData = [AllData trackedPar]; 

%In the AllData structured array you allow gaps in the trajectories
%So need to re-slice each trajectory to get rid of gaps. 
%Make a cell array of trajectories
CellTracks = cell(1);
iter = 1;
for i=1:size(AllData,2)
    if size(AllData(i).xy,1) >= MinTrajLength
        %Now slice up trajectory to get rid of gaps
        currFrame = AllData(i).Frame;
        currTrack = AllData(i).xy;
        %check for gaps - expect a difference of 1 between frames if there
        %are no gaps, so search for difference of 2:
        Idx = find(diff(currFrame)==2);
        %If there were no gaps, just save:
        if isempty(Idx)           
            CellTracks{iter} = currTrack;
            iter = iter + 1;
        else
            %Modify Idx:
            Idx_slice = [0 Idx length(currFrame)];
            %So there are gaps:
            %Slice up trajectories if they satisfy MinTrajLength 
            for j=2:length(Idx_slice)
                if size(currTrack(Idx_slice(j-1)+1:Idx_slice(j),:),1) >= MinTrajLength
                    CellTracks{iter} = currTrack(Idx_slice(j-1)+1:Idx_slice(j),:);
                    iter = iter + 1;
                end
            end
        end
    end
end
        
        
clear currFrame currTrack iter i Idx Idx_slice
toc;
 
%Save a workspace with the 
save([path2,'tmp/', InputFile], 'CellTracks');
 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%% Run vbSPT on the data %%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
R=VB3_HMManalysis('{vbaddress}.m'); % CHANGE HERE
 
%Now distill out the key things:
%CellTrackViterbiClass = R.Wbest.est2.viterbi;
 
%Display the output:
%disp('====================================================');
%VB3_getResult('{vbname}');
toc;
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%% SAVE THE DATA %%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%save([path2, 'input/', InputFile], 'CellTracks', 'CellTrackViterbiClass');
