
function hand = plotc(X, Y, C, varargin)
% Plots a 2D line using C as color according to the present colormap
% Gives a handle to a surface object.
% Can handle extra arguments of the kind 'Property', 'value' pairs.
%
% hand = plotc(X, Y, C);
%
% Fredrik Persson, freddie.persson@gmail.com

hand = surface(...
  'XData',[X(:) X(:)],...
  'YData',[Y(:) Y(:)],...
  'ZData',zeros(length(X(:)),2),...
  'CData',[C(:) C(:)],...
  'FaceColor','none',...
  'EdgeColor','flat',...
  'Marker','none',...
  'CDataMapping', 'scaled');

if nargin > 3
    set(hand,varargin{:})
end
end